'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _actionTypes = require('../constants/action-types');

var actionTypes = _interopRequireWildcard(_actionTypes);

var _immutable = require('immutable');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

var initialState = (0, _immutable.fromJS)({});

var withoutPath = function withoutPath(state, path) {
    var _path = _toArray(path),
        key = _path[0],
        restPath = _path.slice(1);

    if (restPath.length) {
        var newMap = (0, _immutable.fromJS)(_defineProperty({}, key, withoutPath(state.get(key), restPath)));
        return state.merge(newMap);
    } else {
        return state.delete(key);
    }
};

var entities = function entities() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    if (action.type === actionTypes.RESET) {
        return 'entities' in action ? action.entities : initialState;
    } else if (action.type === actionTypes.MUTATE_START && action.optimisticEntities) {
        return state.merge(action.optimisticEntities);
    } else if (action.type === actionTypes.MUTATE_FAILURE && action.originalEntities) {
        return state.merge(action.originalEntities);
    } else if (action.type === actionTypes.REQUEST_SUCCESS || action.type === actionTypes.MUTATE_SUCCESS) {
        return state.merge(action.entities);
    } else if (action.type === actionTypes.REMOVE_ENTITIES) {
        return action.paths.reduce(function (accum, path) {
            return withoutPath(accum, path);
        }, state);
    } else if (action.type === actionTypes.REMOVE_ENTITY) {
        return withoutPath(state, action.path);
    } else {
        return state;
    }
};

exports.default = entities;