'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.queryCount = exports.lastUpdated = exports.status = exports.isPending = exports.isFinished = undefined;

var _queryKey = require('../lib/query-key');

var getQueryState = function getQueryState(urlOrConfig, body, queriesState, queryStateKey) {
    var queryKey = void 0;

    if (typeof urlOrConfig === 'string') {
        queryKey = (0, _queryKey.reconcileQueryKey)({ url: urlOrConfig, body: body });
    } else {
        queryKey = (0, _queryKey.reconcileQueryKey)(urlOrConfig);
    }

    return queriesState.getIn([queryKey, queryStateKey]);
};

var isFinished = exports.isFinished = function isFinished(urlOrConfig, body) {
    return function (queriesState) {
        return getQueryState(urlOrConfig, body, queriesState, 'isFinished');
    };
};

var isPending = exports.isPending = function isPending(urlOrConfig, body) {
    return function (queriesState) {
        return getQueryState(urlOrConfig, body, queriesState, 'isPending');
    };
};

var status = exports.status = function status(urlOrConfig, body) {
    return function (queriesState) {
        return getQueryState(urlOrConfig, body, queriesState, 'status');
    };
};

var lastUpdated = exports.lastUpdated = function lastUpdated(urlOrConfig, body) {
    return function (queriesState) {
        return getQueryState(urlOrConfig, body, queriesState, 'lastUpdated');
    };
};

var queryCount = exports.queryCount = function queryCount(urlOrConfig, body) {
    return function (queriesState) {
        return getQueryState(urlOrConfig, body, queriesState, 'queryCount');
    };
};